| Qore FileLocationHandler Module Reference 2.0

Public Attributes | Protected Member Functions | List of all members
FileLocationHandler::FileLocationHandlerFile Class Reference

The class for handling "file://" locations. More...

Inheritance diagram for FileLocationHandler::FileLocationHandlerFile:
[legend]

## Public Attributes
const | FileLocationOpts = ...
| Valid common file location options.
const | FileLocationReadOpts = ...
| Valid common file location options.
const | FileLocationWriteOpts = ...
| Valid file location write options.

## Protected Member Functions
binary | getBinaryFileImpl (string scheme, string location, *hash< auto > opts)
| Retrieves a binary file from the given location. More...
Qore::InputStream | getBinaryStreamImpl (string scheme, string location, *hash< auto > opts)
| Retrieves a binary file from the given location. More...
OutputStreamWrapper | getOutputStreamImpl (string scheme, string location, *hash< auto > opts)
| Returns an output stream for writing data to the given location. More...
hash< string, hash< FileHandlerOptionInfo > > | getReadOptionsImpl ()
| Gets supported read options. More...
Qore::StreamReader | getStreamReaderImpl (string scheme, string location, *hash< auto > opts)
| Returns a stream reader for the file's data at the given location. More...
string | getTextFileImpl (string scheme, string location, *hash< auto > opts)
| Retrieves a text file from the given location. More...
hash< string, hash< FileHandlerOptionInfo > > | getWriteOptionsImpl ()
| Gets supported write options. More...
| writeFileImpl (string scheme, string location, data contents, *hash< auto > opts)
| Writes data to a file at the given location. More...

## Additional Inherited Members
Public Member Functions inherited from FileLocationHandler::AbstractFileLocationHandler
binary | getBinaryFile (string scheme, string location, *hash< auto > opts)
| Retrieves a binary file from the given location. More...
Qore::InputStream | getBinaryStream (string scheme, string location, *hash< auto > opts)
| Retrieves a binary file from the given location. More...
OutputStreamWrapper | getOutputStream (string scheme, string location, *hash< auto > opts)
| Returns an output stream for writing data to the given location. More...
hash< string, hash< FileHandlerOptionInfo > > | getReadOptions ()
| Gets supported read options. More...
Qore::StreamReader | getStreamReader (string scheme, string location, *hash< auto > opts)
| Returns a string stream for the file's data at the given location. More...
string | getTextFile (string scheme, string location, *hash< auto > opts)
| Retrieves a text file from the given location. More...
hash< string, hash< FileHandlerOptionInfo > > | getWriteOptions ()
| Gets supported write options. More...
| writeFile (string scheme, string location, data contents, *hash< auto > opts)
| Writes data to a file at the given location. More...
Static Protected Member Functions inherited from FileLocationHandler::AbstractFileLocationHandler
static string | forceEncoding (string str, *string encoding)
| Returns a string tagged with the given encoding, if any.

## Detailed Description

The class for handling "file://" locations.

## Member Function Documentation

## ◆ getBinaryFileImpl()

binary FileLocationHandler::FileLocationHandlerFile::getBinaryFileImpl | ( | string | scheme,
|  | string | location,
|  | *hash< auto > | opts
| ) |  |
| protected virtual

Retrieves a binary file from the given location.

Parameters

  scheme | the scheme being used
  location | the location string without the scheme
  opts | read options

Returns
  the binary data of the file's contents, if it can be retrieved

Exceptions

  FILE-READ-ERROR | an I/O or other error occurred when reading the file

Note
  Supports environment variable substitution in location

Implements FileLocationHandler::AbstractFileLocationHandler.

## ◆ getBinaryStreamImpl()

Qore::InputStream FileLocationHandler::FileLocationHandlerFile::getBinaryStreamImpl | ( | string | scheme,
|  | string | location,
|  | *hash< auto > | opts
| ) |  |
| protected virtual

Retrieves a binary file from the given location.

Parameters

  scheme | the scheme being used
  location | the location string without the scheme
  opts | read options

Returns
  an input stream of the file's contents, if it can be retrieved

Note
  Supports environment variable substitution in location

Implements FileLocationHandler::AbstractFileLocationHandler.

## ◆ getOutputStreamImpl()

OutputStreamWrapper FileLocationHandler::FileLocationHandlerFile::getOutputStreamImpl | ( | string | scheme,
|  | string | location,
|  | *hash< auto > | opts
| ) |  |
| protected virtual

Returns an output stream for writing data to the given location.

Parameters

  scheme | the scheme being used
  location | the location string without the scheme
  opts | write options

Returns
  an output stream for writing to the file

Note
  - OutputStream::close() must be called to close the stream after writing terminates in order to avoid a deadlock
  - Supports environment variable substitution in location

Implements FileLocationHandler::AbstractFileLocationHandler.

## ◆ getReadOptionsImpl()

hash<string, hash<FileHandlerOptionInfo> > FileLocationHandler::FileLocationHandlerFile::getReadOptionsImpl | ( |  | ) |
| protected virtual

Gets supported read options.

Returns
  supported read options

Implements FileLocationHandler::AbstractFileLocationHandler.

## ◆ getStreamReaderImpl()

Qore::StreamReader FileLocationHandler::FileLocationHandlerFile::getStreamReaderImpl | ( | string | scheme,
|  | string | location,
|  | *hash< auto > | opts
| ) |  |
| protected virtual

Returns a stream reader for the file's data at the given location.

Parameters

  scheme | the scheme being used
  location | the location string without the scheme
  opts | read options

Returns
  a stream reader for the file's contents, if it can be retrieved

Note
  Supports environment variable substitution in location

Implements FileLocationHandler::AbstractFileLocationHandler.

## ◆ getTextFileImpl()

string FileLocationHandler::FileLocationHandlerFile::getTextFileImpl | ( | string | scheme,
|  | string | location,
|  | *hash< auto > | opts
| ) |  |
| protected virtual

Retrieves a text file from the given location.

Parameters

  scheme | the scheme being used
  location | the location string without the scheme
  opts | read options

Returns
  the string of the file's contents, if it can be retrieved

Exceptions

  FILE-READ-ERROR | an I/O or other error occurred when reading the file

Note
  Supports environment variable substitution in location

Implements FileLocationHandler::AbstractFileLocationHandler.

## ◆ getWriteOptionsImpl()

hash<string, hash<FileHandlerOptionInfo> > FileLocationHandler::FileLocationHandlerFile::getWriteOptionsImpl | ( |  | ) |
| protected virtual

Gets supported write options.

Returns
  supported write options

Implements FileLocationHandler::AbstractFileLocationHandler.

## ◆ writeFileImpl()

FileLocationHandler::FileLocationHandlerFile::writeFileImpl | ( | string | scheme,
|  | string | location,
|  | data | contents,
|  | *hash< auto > | opts
| ) |  |
| protected virtual

Writes data to a file at the given location.

Parameters

  scheme | the scheme being used
  location | the location string without the scheme
  contents | the file's contents
  opts | write options

Note
  Supports environment variable substitution in location

Implements FileLocationHandler::AbstractFileLocationHandler.